100 '*****************************************************************'
110 '*                          C O N F I G B                        *'
120 '*---------------------------------------------------------------*'
130 '*  Task        : Displays the Configuration of the PC           *'
140 '*                                                               *'
150 '*  Author         : MICHAEL TISCHER                             *'
160 '*  developed on   : 7.20.87                                     *'
170 '*  last Update    : 9.21.87                                     *'
180 '*****************************************************************'
190 '
200 CLS : KEY OFF
210 PRINT"WARNING: This program should only be started if the GWBASIC "
220 PRINT"was started from the DOS level with <GWBASIC  /m60000>."
230 PRINT : PRINT"If this was not the case, then input <s> for Stop."
240 PRINT"Else press any key ...";
250 A$ = INKEY$ : IF A$ = "s" THEN END
260 IF A$ = "" THEN 250
270 GOSUB 60000              'Install Function for Interrupt Call 
280 CLS                      'Clear Screen 
290 DEF SEG = &HF000         'BIOS-Segment
300 PRINT "CONFIG (c) 1987 by Michael Tischer"
310 PRINT
320 PRINT "Configuration of Your PC"
330 PRINT "-----------------------------------------------------------"
340 PRINT "PC-Type                         : "; 'determine PC type
350 IF PEEK(&HFFFE) = &HFF THEN PRINT "PC" : GOTO 390
360 IF PEEK(&HFFFE) = &HFE THEN PRINT "XT" : GOTO 390
370 IF PEEK(&HFFFE) = &HFC THEN PRINT "AT" : GOTO 390
380 PRINT "unknown"
390 PRINT "Processor                       : 80";
400 IF PEEK(&HFFFE) = &HFC THEN PRINT "286" ELSE PRINT "88"
410 INR% = &H12                          'BIOS-Interrupt reads RAM size
420 DEF SEG                              'Set BASIC-Segment again
430 CALL IA(INR%,RAMHI%,RAMLO%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%)
440 PRINT "RAM-Memory (Main Circuit Board) :";RAMHI%*256+RAMLO%;"KB"
450 DEF SEG = &HF000                     'BIOS-Segment
460 IF PEEK(&HFFFE) <> &HFC THEN 520     'branch if not AT
470 DEF SEG                              'set BASIC-Segment again
480 INR% = &H15                          'Call Cassette interrupt
490 RAMHI% = &H88               'Function for reading of HI-RAM size
500 CALL IA(INR%,RAMHI%,RAMLO%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%)
510 PRINT "Additional RAM-Memory           :";RAMHI%*256+RAMLO%;"KB beyond 1 MB"
520 DEF SEG                              'Set BASIC-Segment again
525 INR% = &H11                 'BIOS-Interrupt reads Configuration
530 CALL IA(INR%,CONFHI%,CONFLO%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%)
540 PRINT "Video mode after Start          : ";
550 IF CONFLO% AND 48 = 0 THEN PRINT"undefined" : GOTO 590
560 IF CONFLO% AND 48 = 16 THEN PRINT"40*25 Character, Color-Card" : GOTO 590
570 IF CONFLO% AND 48 = 32 THEN PRINT"80*25 Character, Color Card" : GOTO 590
580 PRINT"80*25 Character, Mono-Card"
590 PRINT"Disk drives                     :";INT(CONFLO%/64)+1
600 PRINT"RS232 cards                     :";INT(CONFHI%/2) AND 3
610 PRINT"Printer cards                   :";INT(CONFHI%/64)
620 PRINT
630 END
640 '
60000 '***************************************************************'
60010 '* Initialize the Routine for Interrupt-Call                   *'
60020 '*-------------------------------------------------------------*'
60030 '* Input: none                                                 *'
60040 '* Output: IA is the Start address of the Interrupt-Routine    *'
60050 '***************************************************************'
60060 '
60070 IA=60000!      'Start address of the Routine in the BASIC-Segment
60080 DEF SEG        'Set BASIC-Segment 
60090 RESTORE 60130
60100 FOR I% = 0 TO 160 : READ X% : POKE IA+I%,X% : NEXT  'Poke Routine 
60110 RETURN                                        'back to Caller
60120 '
60130 DATA  85,139,236, 30,  6,139,118, 30,139,  4,232,140,  0,139,118
60140 DATA  12,139, 60,139,118,  8,139,  4, 61,255,255,117,  2,140,216
60150 DATA 142,192,139,118, 28,138, 36,139,118, 26,138,  4,139,118, 24
60160 DATA 138, 60,139,118, 22,138, 28,139,118, 20,138, 44,139,118, 18
60170 DATA 138, 12,139,118, 16,138, 52,139,118, 14,138, 20,139,118, 10
60180 DATA 139, 52, 85,205, 33, 93, 86,156,139,118, 12,137, 60,139,118
60190 DATA  28,136, 36,139,118, 26,136,  4,139,118, 24,136, 60,139,118
60200 DATA  22,136, 28,139,118, 20,136, 44,139,118, 18,136, 12,139,118
60210 DATA  16,136, 52,139,118, 14,136, 20,139,118,  8,140,192,137,  4
60220 DATA  88,139,118,  6,137,  4, 88,139,118, 10,137,  4,  7, 31, 93
60230 DATA 202, 26,  0, 91, 46,136, 71, 66,233,108,255
